-- name: [CS] Paper Partners 64 + TTYD 3.2
-- description: Skinpack of famous friends from the Paper Mario series! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local E_MODEL_GOOMBELLA = smlua_model_util_get_id("goombella_geo")
local E_MODEL_GOOMBARIO = smlua_model_util_get_id("goombario_geo")
local E_MODEL_KOOPER = smlua_model_util_get_id("kooper_geo")
local E_MODEL_KOOPS = smlua_model_util_get_id("koops_geo")
local E_MODEL_PARAKARRY = smlua_model_util_get_id("parakarry_geo")
local E_MODEL_BOMBETTE = smlua_model_util_get_id("bombette_geo")
local E_MODEL_BOBBERY = smlua_model_util_get_id("bobbery_geo")
local E_MODEL_WATT = smlua_model_util_get_id("watt_geo")
local E_MODEL_SUSHIE = smlua_model_util_get_id("sushie_geo")
local E_MODEL_LAKILESTER = smlua_model_util_get_id("lakilester_geo")
local E_MODEL_BOW = smlua_model_util_get_id("bow_geo")
local E_MODEL_JERRY = smlua_model_util_get_id("jerry_geo")
local E_MODEL_MOWZ = smlua_model_util_get_id("mowz_geo")
local E_MODEL_FLURRIE = smlua_model_util_get_id("flurrie_geo")
local E_MODEL_BY_G_1 = smlua_model_util_get_id("byoshi_g_1_geo")
local E_MODEL_BY_R_2 = smlua_model_util_get_id("byoshi_r_2_geo")
local E_MODEL_BY_B_3 = smlua_model_util_get_id("byoshi_b_3_geo")
local E_MODEL_BY_O_4 = smlua_model_util_get_id("byoshi_o_4_geo")
local E_MODEL_BY_WM_5 = smlua_model_util_get_id("byoshi_wm_5_geo")
local E_MODEL_BY_BK_6 = smlua_model_util_get_id("byoshi_bk_6_geo")
local E_MODEL_BY_W_7 = smlua_model_util_get_id("byoshi_w_7_geo")
local E_MODEL_SCREAMY = smlua_model_util_get_id("screamy_geo")
local E_MODEL_VIVIAN = smlua_model_util_get_id("vivian_geo")
local E_MODEL_HAYZEE = smlua_model_util_get_id("hayzee_geo")
local E_MODEL_BLOOEY = smlua_model_util_get_id("blooey_geo")
local E_MODEL_TORQUE = smlua_model_util_get_id("torque_geo")
local E_MODEL_PRINCESSCC = smlua_model_util_get_id("princesscc_geo")
local E_MODEL_SHYBANDIT = smlua_model_util_get_id("shybandit_geo")
local E_MODEL_PIPER = smlua_model_util_get_id("piper_geo")

local TEX_GOOMBELLA = get_texture_info("goombella_icon")
local TEX_GOOMBARIO = get_texture_info("goombario_icon")
local TEX_KOOPER = get_texture_info("kooper_icon")
local TEX_KOOPS = get_texture_info("koops_icon")
local TEX_PARAKARRY = get_texture_info("parakarry_icon")
local TEX_BOMBETTE = get_texture_info("bombette_icon")
local TEX_BOBBERY = get_texture_info("bobbery_icon")
local TEX_WATT = get_texture_info("watt_icon")
local TEX_SUSHIE = get_texture_info("sushie_icon")
local TEX_LAKILESTER = get_texture_info("lakilester_icon")
local TEX_BOW = get_texture_info("bow_icon")
local TEX_JERRY = get_texture_info("jerry_icon")
local TEX_MOWZ = get_texture_info("mowz_icon")
local TEX_FLURRIE = get_texture_info("flurrie_icon")
local TEX_BY_G_1 = get_texture_info("by_g_1")
local TEX_BY_R_2 = get_texture_info("by_r_2")
local TEX_BY_B_3 = get_texture_info("by_b_3")
local TEX_BY_O_4 = get_texture_info("by_o_4")
local TEX_BY_WM_5 = get_texture_info("by_wm_5")
local TEX_BY_BK_6 = get_texture_info("by_bk_6")
local TEX_BY_W_7 = get_texture_info("by_w_7")
local TEX_SCREAMY = get_texture_info("screamy_icon")
local TEX_VIVIAN = get_texture_info("vivian_icon")
local TEX_HAYZEE = get_texture_info("hayzee_icon")
local TEX_BLOOEY = get_texture_info("blooey_icon")
local TEX_TORQUE = get_texture_info("torque_icon")
local TEX_PRINCESSCC = get_texture_info("princesscc_icon")
local TEX_SHYBANDIT = get_texture_info("shybandit_icon")
local TEX_PIPER = get_texture_info("piper_icon")

local E_MODEL_STAR_CRYSTAL = smlua_model_util_get_id("crystal_star_geo")
local TEX_STAR_CRYSTAL = get_texture_info("star_c_crystal")

local E_MODEL_STAR_DIAMOND = smlua_model_util_get_id("diamond_star_geo")
local TEX_STAR_DIAMOND = get_texture_info("star_c_diamond")

local E_MODEL_STAR_EMERALD = smlua_model_util_get_id("emerald_star_geo")
local TEX_STAR_EMERALD = get_texture_info("star_c_emerald")

local E_MODEL_STAR_GOLD = smlua_model_util_get_id("gold_star_geo")
local TEX_STAR_GOLD = get_texture_info("star_c_gold")

local E_MODEL_STAR_RUBY = smlua_model_util_get_id("ruby_star_geo")
local TEX_STAR_RUBY = get_texture_info("star_c_ruby")

local E_MODEL_STAR_SAPPHIRE = smlua_model_util_get_id("sapphire_star_geo")
local TEX_STAR_SAPPHIRE = get_texture_info("star_c_sapphire")

local E_MODEL_STAR_GARNET = smlua_model_util_get_id("garnet_star_geo")
local TEX_STAR_GARNET = get_texture_info("star_c_garnet")

local E_MODEL_STAR_ELDSTAR = smlua_model_util_get_id("eldstar_geo")
local TEX_STAR_ELDSTAR = get_texture_info("eldstar_icon")

local E_MODEL_STAR_MAMAR = smlua_model_util_get_id("mamar_geo")
local TEX_STAR_MAMAR = get_texture_info("mamar_icon")

local E_MODEL_STAR_SKOLAR = smlua_model_util_get_id("skolar_geo")
local TEX_STAR_SKOLAR = get_texture_info("skolar_icon")

local E_MODEL_STAR_MUSKULAR = smlua_model_util_get_id("muskular_geo")
local TEX_STAR_MUSKULAR = get_texture_info("muskular_icon")

local E_MODEL_STAR_MISSTAR = smlua_model_util_get_id("misstar_geo")
local TEX_STAR_MISSTAR = get_texture_info("misstar_icon")

local E_MODEL_STAR_KLEVAR = smlua_model_util_get_id("klevar_geo")
local TEX_STAR_KLEVAR = get_texture_info("klevar_icon")

local E_MODEL_STAR_KALMAR = smlua_model_util_get_id("kalmar_geo")
local TEX_STAR_KALMAR = get_texture_info("kalmar_icon")

local TEXT_MOD_NAME = "[CS] Paper Partners 64 + TTYD"

local VOICETABLE_GOOMBA = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'Gyah.ogg',
    [CHAR_SOUND_HOOHOO] = 'Ghoohoo (2).ogg',
    [CHAR_SOUND_YAHOO] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_UH] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_HRMM] = 'Ghrm.ogg',
    [CHAR_SOUND_WAH2] = 'Gwah.ogg',
    [CHAR_SOUND_WHOA] = 'Gwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Geeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Gattacked.ogg',
    [CHAR_SOUND_OOOF] = 'Gooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ghere we go.ogg',
    [CHAR_SOUND_YAWNING] = 'Gyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Gwaaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Ghaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Ghaha.ogg',
    [CHAR_SOUND_UH2] = 'Guh.ogg',
    [CHAR_SOUND_UH2_2] = 'Guh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Gfire.ogg',
    [CHAR_SOUND_DYING] = 'Gdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PANTING] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_COUGHING1] = 'Gcoughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Gyah (2).ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Ghoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Gsurprise.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Gwah.ogg',
    [CHAR_SOUND_DROWNING] = 'Gdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Gwah_punch.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Gyahooyipee.ogg',
    [CHAR_SOUND_DOH] = 'Gdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Ghello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Gquestion.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Gsolongabowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Gimatired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Gletsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Goki doki.ogg',
}

local VOICETABLE_KOOPA = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Kya.ogg', 'Kwah.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Khoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Kyahoo.ogg',
    [CHAR_SOUND_UH] = 'Kuh.ogg',
    [CHAR_SOUND_HRMM] = 'Khrm.ogg',
    [CHAR_SOUND_WAH2] = 'Kwah.ogg',
    [CHAR_SOUND_WHOA] = 'Kwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Keh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Kdoh.ogg',
    [CHAR_SOUND_OOOF] = 'Khurt.ogg',
    [CHAR_SOUND_OOOF2] = 'Keh2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_YAWNING] = 'Kyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_HAHA] = 'Khaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Khaha.ogg',
    [CHAR_SOUND_UH2] = 'Kuh.ogg',
    [CHAR_SOUND_UH2_2] = 'Kuh2-2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Kfire.ogg',
    [CHAR_SOUND_DYING] = 'Kdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Kcoughing2.ogg',
    [CHAR_SOUND_PANTING] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING1] = 'Kcoughing2.ogg',
    [CHAR_SOUND_COUGHING2] = 'Kcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Kyah2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Khoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Kwoaaaw.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Kwah2.ogg',
    [CHAR_SOUND_DROWNING] = 'Kdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Kwah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Ksolonga_bowser.ogg', 'Ktwirl_bounce.ogg' },
    [CHAR_SOUND_DOH] = 'Kdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Khello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Ktwirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Ksolonga_bowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Khurt.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Klets a go.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Kokey_dokey.ogg',
}

local VOICETABLE_BOBOMB = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Bo_yah.ogg', 'Bo_yah2.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Bo_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Bo_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Bo_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Bo_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Bo_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Bo_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Bo_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Bo_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Bo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Bo_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Bo_herewego.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Bo_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Bo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Bo_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Bo_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Bo_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Bo_onfire.ogg',
    [CHAR_SOUND_DYING] = 'Bo_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Bo_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Bo_panting.ogg',
    [CHAR_SOUND_COUGHING1] = 'Bo_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Bo_coughing2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Bo_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Bo_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Bo_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Bo_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'Bo_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Bo_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Bo_yahoo.ogg', 'Bo_waha.ogg', 'Bo_wihee.ogg' },
    [CHAR_SOUND_DOH] = 'Bo_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Bo_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Bo_solongabowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Bo_letsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Bo_okey_dokey.ogg',
}
local VOICETABLE_WATT = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'W_yah.ogg', 'W_yah2.ogg', 'W_yah3.ogg', 'W_wah.ogg' },
    [CHAR_SOUND_HOOHOO] = 'W_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'W_whooo.ogg',
    [CHAR_SOUND_UH] = 'W_uh.ogg',
    [CHAR_SOUND_HRMM] = 'W_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'W_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'W_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'W_euuh.ogg',
    [CHAR_SOUND_ATTACKED] = { 'W_attacked.ogg', 'W_attacked_2.ogg', 'W_attacked_3.ogg' },
    [CHAR_SOUND_OOOF] = 'W_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'W_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'W_here_we_go.ogg',
    [CHAR_SOUND_YAWNING] = 'W_yawning.ogg',
    [CHAR_SOUND_SNORING1] = 'W_snoring_1.ogg',
    [CHAR_SOUND_SNORING2] = 'W_snoring_2.ogg',
    [CHAR_SOUND_SNORING3] = 'W_snoring_3.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'W_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'W_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'W_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'W_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'W_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'W_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'W_dying.ogg',
    [CHAR_SOUND_PANTING] = { 'W_panting.ogg', 'W_panting2.ogg', 'W_panting3.ogg' },
    [CHAR_SOUND_PANTING_COLD] = 'W_panting_cold.ogg',
    [CHAR_SOUND_COUGHING1] = 'W_coughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'W_coughing_2.ogg',
    [CHAR_SOUND_COUGHING3] = 'W_coughing_3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'W_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'W_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'W_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'W_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'W_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'W_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'W_yahoo.ogg', 'W_yahoo2.ogg', 'W_yahoo3.ogg', 'W_yahoo4.ogg' },
    [CHAR_SOUND_DOH] = 'W_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'W_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'W_so_longa_bowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'W_ima_tired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'W_lets_a_go.ogg',
}

local VOICETABLE_SUSHIE = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'bubbble1.ogg',
    [CHAR_SOUND_HOOHOO] = 'bubble2.ogg',
    [CHAR_SOUND_YAHOO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_UH] = 'wet ladning.ogg',
    [CHAR_SOUND_HRMM] = 'bubbble1.ogg',
    [CHAR_SOUND_WAH2] = 'bubble high$.ogg',
    [CHAR_SOUND_WHOA] = 'wet ladning.ogg',
    [CHAR_SOUND_EEUH] = 'bubble2.ogg',
    [CHAR_SOUND_ATTACKED] = 'bubblerun.ogg',
    [CHAR_SOUND_OOOF] = 'wet ladning.ogg',
    [CHAR_SOUND_OOOF2] = 'bubble2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_HAHA] = 'bubble2.ogg',
    [CHAR_SOUND_HAHA_2] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_UH2] = 'bubblerun.ogg',
    [CHAR_SOUND_UH2_2] = 'bubblerun.ogg',
    [CHAR_SOUND_ON_FIRE] = 'bubblepop2.ogg',
    [CHAR_SOUND_DYING] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_PANTING] = 'sleeping1.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'bubbble1.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_DROWNING] = 'bubblepop2_fade.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'bubble2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'SUSHIESHOT.ogg',
    [CHAR_SOUND_DOH] = 'wet ladning.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SUSHIESHOT.ogg',
}

local VOICETABLE_LAKILESTER = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'L_ya.ogg', 'L_yah2.ogg', 'L_yah3.ogg' },
    [CHAR_SOUND_HOOHOO] = 'L_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'L_yahoo (2).ogg',
    [CHAR_SOUND_UH] = 'L_uh.ogg',
    [CHAR_SOUND_HRMM] = 'L_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'L_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'L_woah.ogg',
    [CHAR_SOUND_EEUH] = 'L_euuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'L_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'L_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'L_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'L_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'L_falling2.ogg',
    [CHAR_SOUND_HAHA] = 'L_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'L_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'L_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'L_uh2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'L_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'L_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'L_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'L_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'L_mamamia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'L_groundpound.ogg',
    [CHAR_SOUND_DROWNING] = 'L_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'L_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'L_yahoo.ogg', 'L_yipee2.ogg', 'L_yahoo (2).ogg', 'L_waha (2).ogg', 'L_waha.ogg' },
    [CHAR_SOUND_DOH] = 'L_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'L_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'L_so_longa_bowser.ogg',
}

local VOICETABLE_BOW = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Lb_yah1.ogg', 'Lb_haha.ogg', 'Lb_eeuh.ogg', 'Lb_doh.ogg' },
    [CHAR_SOUND_HOOHOO] = 'Lb_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'Lb_yahoo.ogg',
    [CHAR_SOUND_UH] = 'Lb_uh.ogg',
    [CHAR_SOUND_HRMM] = 'Lb_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'Lb_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'Lb_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'Lb_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Lb_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'Lb_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Lb_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Lb_here_we_go.ogg',
    [CHAR_SOUND_YAWNING] = 'Lb_yawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Lb_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Lb_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Lb_haha_2.ogg',
    [CHAR_SOUND_UH2] = 'Lb_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'Lb_uh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Lb_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'Lb_dying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Lb_panting_cold.ogg',
    [CHAR_SOUND_PANTING] = 'Lb_panting.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Lb_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Lb_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Lb_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Lb_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'Lb_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Lb_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Lb_yahoo.ogg', 'Lb_yahoo2.ogg', 'Lb_yahoo3.ogg', 'Lb_yahoo4.ogg', 'Lb_yahoo5.ogg', 'Lb_waha.ogg', 'Lb_yipee.ogg' },
    [CHAR_SOUND_DOH] = 'Lb_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Lb_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Lb_so_longa_bowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Lb_lets_a_go.ogg',
}
local VOICETABLE_MOWZ = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'ms_jump.ogg', 'ms_jump3.ogg' },
    [CHAR_SOUND_HOOHOO] = 'ms_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'ms_yahoo.ogg',
    [CHAR_SOUND_UH] = 'ms_uh.ogg',
    [CHAR_SOUND_HRMM] = 'ms_eeuh.ogg',
    [CHAR_SOUND_WAH2] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_WHOA] = 'ms_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'ms_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'ms_hurt.ogg',
    [CHAR_SOUND_OOOF] = 'ms_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'ms_ooof.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ms_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ms_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'ms_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'ms_haha.ogg',
    [CHAR_SOUND_UH2] = 'ms_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'ms_uh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ms_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'ms_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'ms_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ms_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'ms_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_DROWNING] = 'ms_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'ms_ground_pound.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'ms_yahoo.ogg', 'ms_waha.ogg', 'ms_yipee.ogg' },
    [CHAR_SOUND_DOH] = 'ms_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'ms_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'ms_twirl_bounce.ogg',
}
local VOICETABLE_FLURRIE = {
    [CHAR_SOUND_ATTACKED] = 'fl_attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'fl_coughing1.ogg',
    [CHAR_SOUND_COUGHING2] = 'fl_coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'fl_coughing3.ogg',
    [CHAR_SOUND_DOH] = 'fl_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'fl_dying.ogg',
    [CHAR_SOUND_DYING] = 'fl_dying.ogg',
    [CHAR_SOUND_EEUH] = 'fl_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'fl_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'fl_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'fl_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'fl_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'fl_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'fl_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'fl_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'fl_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'fl_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'fl_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'fl_ooof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'fl_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'fl_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'fl_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'fl_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'fl_yah5.ogg',
    [CHAR_SOUND_UH] = 'fl_uh.ogg',
    [CHAR_SOUND_UH2] = 'fl_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'fl_uh2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'fl_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'fl_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'fl_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'fl_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'fl_yahoo.ogg', 'fl_yahoo1.ogg', 'fl_yahoo2.ogg', 'fl_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'fl_yah1.ogg', 'fl_yah2.ogg', 'fl_yah3.ogg', 'fl_yah4.ogg', 'fl_yah5.ogg' },
}
local VOICETABLE_BY = {
    [CHAR_SOUND_YAH_WAH_HOO] = { 'by_yah1.ogg', 'by_yah2.ogg', 'by_yah3.ogg', 'by_yah4.ogg' },
    [CHAR_SOUND_HOOHOO] = 'by_hoohoo.ogg',
    [CHAR_SOUND_YAHOO] = 'by_yahoo.ogg',
    [CHAR_SOUND_UH] = 'by_uh.ogg',
    [CHAR_SOUND_HRMM] = 'by_hrmm.ogg',
    [CHAR_SOUND_WAH2] = 'by_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'by_whoa.ogg',
    [CHAR_SOUND_EEUH] = 'by_eeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'by_attacked.ogg',
    [CHAR_SOUND_OOOF] = 'by_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'by_ooof2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'by_here_we_go.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'by_waaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'by_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'by_haha.ogg',
    [CHAR_SOUND_UH2] = 'by_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'by_uh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'by_on_fire.ogg',
    [CHAR_SOUND_DYING] = 'by_dying.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'by_punch_yah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'by_punch_hoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'by_mama_mia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'by_ground_pound_wah.ogg',
    [CHAR_SOUND_DROWNING] = 'by_drowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'by_punch_wah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'by_yahoo.ogg', 'by_yahoo1.ogg', 'by_yahoo2.ogg', 'by_yahoo3.ogg', 'by_yahoo4.ogg', 'by_yahoo5.ogg' },
    [CHAR_SOUND_DOH] = 'by_doh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'by_twirl_bounce.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'by_so_longa_bowser.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'by_lets_a_go.ogg',
}

local VOICETABLE_VIVIAN = {
    [CHAR_SOUND_ATTACKED] = 'viv_attacked.ogg',
    [CHAR_SOUND_COUGHING1] = 'viv_coughing1.ogg',
    [CHAR_SOUND_COUGHING2] = 'viv_coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'viv_coughing3.ogg',
    [CHAR_SOUND_DOH] = 'viv_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'viv_drowning.ogg',
    [CHAR_SOUND_DYING] = 'viv_dying.ogg',
    [CHAR_SOUND_EEUH] = 'viv_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'viv_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'viv_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'viv_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'viv_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'viv_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'viv_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'viv_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'viv_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'viv_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'viv_oof.ogg',
    [CHAR_SOUND_OOOF2] = 'viv_oof2.ogg',
    [CHAR_SOUND_PANTING] = { 'viv_panting1.ogg', 'viv_panting2.ogg', 'viv_panting3.ogg' },
    [CHAR_SOUND_PUNCH_HOO] = 'viv_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'viv_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'viv_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'viv_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'viv_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'viv_uh.ogg',
    [CHAR_SOUND_UH2] = 'viv_uh2.ogg',
    [CHAR_SOUND_UH2_2] = 'viv_uh2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'viv_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'viv_yah2.ogg',
    [CHAR_SOUND_WHOA] = 'viv_woah.ogg',
    [CHAR_SOUND_YAHOO] = 'viv_yipee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'viv_yipee.ogg', 'viv_yipee1.ogg', 'viv_yipee2.ogg', 'viv_yipee3.ogg', 'viv_yipee4.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'viv_yah1.ogg', 'viv_yah2.ogg', 'viv_yah3.ogg', 'viv_yah4.ogg' },
}
local VOICETABLE_HAYZEE = {
    [CHAR_SOUND_HERE_WE_GO] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_HOOHOO] = 'jump2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'jump.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAHOO] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'crazee_dayzee_song.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = { 'jump.ogg', 'jumping2.ogg' },
}

local VOICETABLE_BLOOEY = {
    [CHAR_SOUND_ATTACKED] = 'blo_attacked.ogg',
    [CHAR_SOUND_DOH] = 'blo_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'blo_drowning.ogg',
    [CHAR_SOUND_DYING] = 'blo_dying.ogg',
    [CHAR_SOUND_EEUH] = 'blo_uh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'blo_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'blo_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'blo_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'blo_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'blo_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'blo_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'blo_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'blo_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'blo_drowning.ogg',
    [CHAR_SOUND_OOOF] = 'blo_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'blo_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'blo_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'blo_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'blo_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'blo_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'blo_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'blo_uh.ogg',
    [CHAR_SOUND_UH2] = 'blo_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'blo_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'blo_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'blo_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'blo_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'blo_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'blo_yahoo.ogg', 'blo_yahoo2.ogg', 'blo_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'blo_yah.ogg', 'blo_yah2.ogg' },
}

local VOICETABLE_CHOMP = {
    [CHAR_SOUND_ATTACKED] = 'pcc_attacked.ogg',
    [CHAR_SOUND_DOH] = 'pcc_ooof.ogg',
    [CHAR_SOUND_DROWNING] = 'pcc_dying.ogg',
    [CHAR_SOUND_DYING] = 'pcc_dying.ogg',
    [CHAR_SOUND_EEUH] = 'pcc_uh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'pcc_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HAHA_2] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'pcc_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'pcc_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'pcc_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'pcc_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'pcc_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'pcc_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'pcc_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'pcc_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'pcc_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'pcc_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'pcc_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'pcc_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'pcc_yahoo.ogg',
    [CHAR_SOUND_UH] = 'pcc_uh.ogg',
    [CHAR_SOUND_UH2] = 'pcc_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'pcc_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'pcc_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'pcc_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'pcc_waaaooow.ogg',
    [CHAR_SOUND_YAHOO] = 'pcc_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'pcc_yahoo.ogg', 'pcc_yahoo2.ogg', 'pcc_yahoo3.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'pcc_yah.ogg', 'pcc_yah2.ogg' },
}

local VOICETABLE_SHY = {
    [CHAR_SOUND_ATTACKED] = 'sb_attacked.ogg',
    [CHAR_SOUND_DOH] = 'sb_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'sb_dying.ogg',
    [CHAR_SOUND_DYING] = 'sb_dying.ogg',
    [CHAR_SOUND_EEUH] = 'sb_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'sb_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'sb_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'sb_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'sb_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'sb_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'sb_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'sb_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'sb_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'sb_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'sb_doh.ogg',
    [CHAR_SOUND_OOOF2] = 'sb_doh.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'sb_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'sb_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'sb_punch_yah.ogg',
    [CHAR_SOUND_SNORING1] = 'sb_snoring1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'sb_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'sb_so_longa_bowser.ogg',
    [CHAR_SOUND_UH] = 'sb_uh.ogg',
    [CHAR_SOUND_UH2] = 'sb_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'sb_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'sb_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'sb_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'sb_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'sb_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'sb_yahoo.ogg', 'sb_yahoo2.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'sb_yah_wah_hoo1.ogg', 'sb_yah_wah_hoo2.ogg', 'sb_yah_wah_hoo3.ogg' },
}

local VOICETABLE_PLANT = {
    [CHAR_SOUND_ATTACKED] = 'pp_attacked.ogg',
    [CHAR_SOUND_DOH] = 'pp_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'pp_drowning.ogg',
    [CHAR_SOUND_DYING] = 'pp_dying.ogg',
    [CHAR_SOUND_EEUH] = 'pp_doh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'pp_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'pp_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'pp_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'pp_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'pp_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'pp_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'pp_mama_mia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'pp_letsa_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'pp_dying.ogg',
    [CHAR_SOUND_OOOF] = 'pp_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'pp_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'pp_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'pp_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'pp_punch_yah.ogg',
    [CHAR_SOUND_PANTING] = 'pp_panting.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'pp_solonga_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'pp_twirl_bounce.ogg',
    [CHAR_SOUND_UH] = 'pp_uh.ogg',
    [CHAR_SOUND_UH2] = 'pp_uh.ogg',
    [CHAR_SOUND_UH2_2] = 'pp_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'pp_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'pp_ground_pound_wah.ogg',
    [CHAR_SOUND_WHOA] = 'pp_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'pp_yahoo.ogg',
    [CHAR_SOUND_YAWNING] = 'pp_yawning.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'pp_yahoo.ogg', 'pp_yahoo2.ogg', 'pp_yahoo3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'pp_yah_wah_hoo1.ogg', 'pp_yah_wah_hoo2.ogg'},
}

local VOICETABLE_SILENT = { nil }

local capGoombella = {
    normal = smlua_model_util_get_id("goombellas_cap_geo"),
    wing = smlua_model_util_get_id("goombellas_wing_cap_geo"),
    metal = smlua_model_util_get_id("goombellas_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("goombellas_metal_wing_cap_geo")
}

local capGoombario = {
    normal = smlua_model_util_get_id("goombarios_cap_geo"),
    wing = smlua_model_util_get_id("goombarios_wing_cap_geo"),
    metal = smlua_model_util_get_id("goombarios_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("goombarios_metal_wing_cap_geo")
}

local capKooper = {
    normal = smlua_model_util_get_id("koopers_cap_geo"),
    wing = smlua_model_util_get_id("koopers_wing_cap_geo"),
    metal = smlua_model_util_get_id("koopers_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("koopers_metal_wing_cap_geo")
}

local capKoops = {
    normal = smlua_model_util_get_id("koops_cap_geo"),
    wing = smlua_model_util_get_id("koopss_wing_cap_geo"),
    metal = smlua_model_util_get_id("koopss_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("koopss_metal_wing_cap_geo")
}

local capParakarry = {
    normal = smlua_model_util_get_id("parakarrys_cap_geo"),
    wing = smlua_model_util_get_id("parakarrys_wing_cap_geo"),
    metal = smlua_model_util_get_id("parakarrys_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("parakarrys_metal_wing_cap_geo")
}

local capBombette = {
    normal = smlua_model_util_get_id("bombette_cap_geo"),
    wing = smlua_model_util_get_id("bombette_wing_cap_geo"),
    metal = smlua_model_util_get_id("bombette_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bombette_metal_wing_cap_geo")
}
local capBobbery = {
    normal = smlua_model_util_get_id("bobbery_cap_geo"),
    wing = smlua_model_util_get_id("bobbery_wing_cap_geo"),
    metal = smlua_model_util_get_id("bobbery_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bobbery_metal_wing_cap_geo")
}
local capWatt = {
    normal = smlua_model_util_get_id("watts_cap_geo"),
    wing = smlua_model_util_get_id("watts_wing_cap_geo"),
    metal = smlua_model_util_get_id("watts_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("watts_metal_wing_cap_geo")
}

local capSushie = {
    normal = smlua_model_util_get_id("sushies_cap_geo"),
    wing = smlua_model_util_get_id("sushies_wing_cap_geo"),
    metal = smlua_model_util_get_id("sushies_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("sushies_metal_wing_cap_geo")
}

local capLakilester = {
    normal = smlua_model_util_get_id("lakilester_cap_geo"),
    wing = smlua_model_util_get_id("lakilester_wing_cap_geo"),
    metal = smlua_model_util_get_id("lakilester_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("lakilester_metal_wing_cap_geo")
}

local capBow = {
    normal = smlua_model_util_get_id("bow_cap_geo"),
    wing = smlua_model_util_get_id("bow_wing_cap_geo"),
    metal = smlua_model_util_get_id("bow_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bow_metal_wing_cap_geo")
}
local capJerry = {
    normal = smlua_model_util_get_id("jerry_cap_geo"),
    wing = smlua_model_util_get_id("jerry_wing_cap_geo"),
    metal = smlua_model_util_get_id("jerry_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("jerry_metal_wing_cap_geo")
}
local capMowz = {
    normal = smlua_model_util_get_id("mowz_cap_geo"),
    wing = smlua_model_util_get_id("mowz_wing_cap_geo"),
    metal = smlua_model_util_get_id("mowz_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mowz_metal_wing_cap_geo")
}
local capFlurrie = {
    normal = smlua_model_util_get_id("flurrie_cap_geo"),
    wing = smlua_model_util_get_id("flurrie_wing_cap_geo"),
    metal = smlua_model_util_get_id("flurrie_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("flurrie_metal_wing_cap_geo")
}
local capBy = {
    normal = smlua_model_util_get_id("byoshi_cap_geo"),
    wing = smlua_model_util_get_id("byoshi_wing_cap_geo"),
    metal = smlua_model_util_get_id("byoshi_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("byoshi_metal_wing_cap_geo")
}
local capScreamy = {
    normal = smlua_model_util_get_id("screamy_cap_geo"),
    wing = smlua_model_util_get_id("screamy_wing_cap_geo"),
    metal = smlua_model_util_get_id("screamy_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("screamy_metal_wing_cap_geo")
}

local capVivian = {
    normal = smlua_model_util_get_id("vivian_cap_geo"),
    wing = smlua_model_util_get_id("vivian_wing_cap_geo"),
    metal = smlua_model_util_get_id("vivian_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("vivian_metal_wing_cap_geo")
}

local capVivian = {
    normal = smlua_model_util_get_id("vivian_cap_geo"),
    wing = smlua_model_util_get_id("vivian_wing_cap_geo"),
    metal = smlua_model_util_get_id("vivian_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("vivian_metal_wing_cap_geo")
}

local capHayzee = {
    normal = smlua_model_util_get_id("hayzee_cap_geo"),
    wing = smlua_model_util_get_id("hayzee_wing_cap_geo"),
    metal = smlua_model_util_get_id("hayzee_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("hayzee_metal_wing_cap_geo")
}

local capBlooey = {
    normal = smlua_model_util_get_id("blooey_cap_geo"),
    wing = smlua_model_util_get_id("blooey_wing_cap_geo"),
    metal = smlua_model_util_get_id("blooey_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("blooey_metal_wing_cap_geo")
}
local capTorque = {
    normal = smlua_model_util_get_id("torque_cap_geo"),
    wing = smlua_model_util_get_id("torque_wing_cap_geo"),
    metal = smlua_model_util_get_id("torque_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("torque_metal_wing_cap_geo")
}
local capPrincesscc = {
    normal = smlua_model_util_get_id("princesscc_cap_geo"),
    wing = smlua_model_util_get_id("princesscc_wing_cap_geo"),
    metal = smlua_model_util_get_id("princesscc_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("princesscc_metal_wing_cap_geo")
}
local capShybandit = {
    normal = smlua_model_util_get_id("shybandit_cap_geo"),
    wing = smlua_model_util_get_id("shybandit_wing_cap_geo"),
    metal = smlua_model_util_get_id("shybandit_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("shybandit_metal_wing_cap_geo")
}

local capPiper = {
    normal = smlua_model_util_get_id("piper_cap_geo"),
    wing = smlua_model_util_get_id("piper_wing_cap_geo"),
    metal = smlua_model_util_get_id("piper_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("piper_metal_wing_cap_geo")
}

local PALETTE_GOOMBARIO = {
    [PANTS]  = "214aa5",
    [SHIRT]  = "9c5210",
    [SHOES]  = "5a2100",
    [SKIN]   = "bd8439",
}

local PALETTE_GOOMBELLA = {
    [PANTS]  = "f00000",
    [SHIRT]  = "bcbe91",
    [SHOES]  = "9c4118",
    [HAIR]   = "efb218",
    [SKIN]   = "d69781",
    [CAP]    = "b7be91",
    [GLOVES] = "ffffff",
}

local PALETTE_KOOPER = {
    [PANTS]  = "d64231",
    [SHIRT]  = "3963ce",
    [GLOVES] = "bdad84",
    [SHOES]  = "b56b31",
    [HAIR]   = "ce9431",
    [SKIN]   = "ce9431",
    [CAP]    = "3963ce",
}

local PALETTE_KOOPS = {
    [PANTS]  = "1d598f",
    [SHIRT]  = "4ea230",
    [GLOVES] = "ddd9cf",
    [SHOES]  = "b6875e",
    [HAIR]   = "f7b218",
    [SKIN]   = "f3b15d",
    [CAP]    = "a8bbd3",
}

local PALETTE_PARAKARRY = {
    [PANTS]  = "7b3908",
    [SHIRT]  = "109c84",
    [GLOVES] = "bdad84",
    [SHOES]  = "ce9431",
    [HAIR]   = "ce9431",
    [SKIN]   = "ce9431",
    [CAP]    = "ce9431",
}

local PALETTE_BOMBETTE = {
    [SHIRT]  = "f8005a",
    [GLOVES] = "ffffff",
    [SHOES]  = "f17b2e",
    [HAIR]   = "ffc81d",
    [SKIN]   = "f8a773",
}

local PALETTE_BOBBERY = {
    [PANTS]  = "4f4fc8",
    [SHIRT]  = "68461c",
    [GLOVES] = "ffffff",
    [SHOES]  = "c8a12f",
    [HAIR]   = "b8b4b8",
    [SKIN]   = "d6c133",
}

local PALETTE_LADY_BOW = {
    [PANTS]  = "d6d65a",
    [SHIRT]  = "f74a31",
    [GLOVES] = "cdfddf",
}

local PALETTE_WATT = {
    [PANTS]  = "73c7ef",
    [SHIRT]  = "f7e329",
    [CAP]    = "f7e329",
}

local PALETTE_SUSHIE = {
    [PANTS]  = "ef7929",
    [SHIRT]  = "7b57f5",
    [GLOVES] = "ffffff",
    [SKIN]   = "e7d37b",
    [CAP]    = "ef92bd",
}

local PALETTE_LAKILESTER = {
    [SHIRT]  = "49ff31",
    [GLOVES] = "ffffff",
    [SHOES]  = "9c5129",
    [SKIN]   = "efaa4a",
}

local PALETTE_MADAME_FLURRIE = {
    [PANTS]  = "458c69",
    [SHIRT]  = "8786d8",
    [SKIN]   = "fee65e",
    [CAP]  = "8786d8",
}

local PALETTE_VIVIAN = {
    [PANTS]  = "E61549",
    [SHIRT]  = "730E79",
    [GLOVES] = "EEEEEE",
    [SKIN]   = "FFA9A4",
}

local PALETTE_MS_MOWZ = {
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "000000",
    [HAIR]   = "3c0000",
    [CAP]    = "ff0000",
}

local PALETTE_SCREAMY = {
    [SHIRT]  = "FFEDE3",
}

local PALETTE_JERRY = {
    [PANTS]  = "951516",
    [SHIRT]  = "8e1618",
    [HAIR]   = "9d561e",
}

local PALETTE_HAYZEE = {
    [PANTS]  = "d3d0d3",
    [SHIRT]  = "8dbf9f",
    [SHOES]  = "f7d794",
    [SKIN]   = "f7d794",
}

local PALETTE_YOSHI_GREEN = {
    [PANTS]  = "cc120d",
    [SHIRT]  = "4bbf20",
    [GLOVES] = "ffffff",
    [HAIR]   = "cc120d",
    [SKIN]   = "d3b718",
    [CAP]    = "e79418",
}

local PALETTE_YOSHI_RED = {
    [PANTS]  = "099455",
    [SHIRT]  = "dd3553",
    [GLOVES] = "ffffff",
    [HAIR]   = "099455",
    [SKIN]   = "d3b718",
    [CAP]    = "535248",
}

local PALETTE_YOSHI_BLUE = {
    [PANTS]  = "de5f95",
    [SHIRT]  = "297ade",
    [GLOVES] = "ffffff",
    [HAIR]   = "de5f95",
    [SKIN]   = "ffffff",
    [CAP]    = "72c5b9",
}

local PALETTE_YOSHI_ORANGE = {
    [PANTS]  = "447ddb",
    [SHIRT]  = "ef7529",
    [GLOVES] = "ffffff",
    [HAIR]   = "447ddb",
    [SKIN]   = "d3b718",
    [CAP]    = "58a93a",
}

local PALETTE_YOSHI_WATERMELON = {
    [PANTS]  = "d53a80",
    [SHIRT]  = "ef90bc",
    [GLOVES] = "ffffff",
    [HAIR]   = "4bbf20",
    [SKIN]   = "ef90bc",
    [CAP]    = "dd3553",
}

local PALETTE_YOSHI_BLACK = {
    [PANTS]  = "f6bb2d",
    [SHIRT]  = "5a595a",
    [GLOVES] = "ffffff",
    [HAIR]   = "dd3553",
    [SKIN]   = "d3b718",
    [CAP]    = "8f8f90",
}

local PALETTE_YOSHI_WHITE = {
    [PANTS]  = "d53a80",
    [SHIRT]  = "bdd7e7",
    [GLOVES] = "ffffff",
    [HAIR]   = "f7db52",
    [SKIN]   = "f4ca3c",
    [CAP]    = "ffffff",
}

local PALETTE_BLOOEY = {
    [SHIRT]  = "da9938",
}

local PALETTE_TORQUE = {
    [SHIRT]  = "67922E",
    [SKIN]  = "DEC77B",
    [GLOVES]  = "FFFFFF",
}

local PALETTE_PRINCESSCC = {
    [SHIRT]  = "000000",
    [PANTS]  = "F4A9AA",
    [GLOVES]  = "FFFFFF",
}

local PALETTE_SHYBANDIT = {
    [SHIRT]  = "5A5A5A",
    [PANTS]  = "E2E1DE",
    [SHOES]  = "7E4E29",
    [GLOVES]  = "FFFFFF",
    [HAIR]  = "421008",
    [SKIN]  = "F0BA07",
    [CAP]  = "E20807",
}

local PALETTE_PIPER = {
    [SHIRT]  = "FF0000",
    [PANTS]  = "FFFFFF",
    [SHOES]  = "c68026",
    [GLOVES]  = "FFFFFF",
    [SKIN]  = "38a31f",
}

local char_add, char_add_caps, char_add_palette, char_add_voice, char_add_star, char_get_voice = _G.charSelect.character_add, _G.charSelect.character_add_caps, _G.charSelect.character_add_palette_preset, _G.charSelect.character_add_voice, _G.charSelect.character_add_celebration_star, _G.charSelect.character_get_voice

_G.charSelect.character_add_caps(E_MODEL_GOOMBELLA, capGoombella)
_G.charSelect.character_add_caps(E_MODEL_GOOMBARIO, capGoombario)
_G.charSelect.character_add_caps(E_MODEL_KOOPER, capKooper)
_G.charSelect.character_add_caps(E_MODEL_KOOPS, capKoops)
_G.charSelect.character_add_caps(E_MODEL_PARAKARRY, capParakarry)
_G.charSelect.character_add_caps(E_MODEL_BOMBETTE, capBombette)
_G.charSelect.character_add_caps(E_MODEL_BOBBERY, capBobbery)
_G.charSelect.character_add_caps(E_MODEL_WATT, capWatt)
_G.charSelect.character_add_caps(E_MODEL_SUSHIE, capSushie)
_G.charSelect.character_add_caps(E_MODEL_LAKILESTER, capLakilester)
_G.charSelect.character_add_caps(E_MODEL_BOW, capBow)
_G.charSelect.character_add_caps(E_MODEL_JERRY, capJerry)
_G.charSelect.character_add_caps(E_MODEL_MOWZ, capMowz)
_G.charSelect.character_add_caps(E_MODEL_FLURRIE, capFlurrie)
_G.charSelect.character_add_caps(E_MODEL_BY_G_1, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_R_2, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_B_3, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_O_4, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_WM_5, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_BK_6, capBy)
_G.charSelect.character_add_caps(E_MODEL_BY_W_7, capBy)
_G.charSelect.character_add_caps(E_MODEL_SCREAMY, capScreamy)
_G.charSelect.character_add_caps(E_MODEL_VIVIAN, capVivian)
_G.charSelect.character_add_caps(E_MODEL_HAYZEE, capHayzee)
_G.charSelect.character_add_caps(E_MODEL_BLOOEY, capBlooey)
_G.charSelect.character_add_caps(E_MODEL_TORQUE, capTorque)
_G.charSelect.character_add_caps(E_MODEL_PRINCESSCC, capPrincesscc)
_G.charSelect.character_add_caps(E_MODEL_SHYBANDIT, capShybandit)
_G.charSelect.character_add_caps(E_MODEL_PIPER, capPiper)

local PM_GOOMBELLA= {
    label = {
        left = get_texture_info("goombella_pm1"),
        right = get_texture_info("goombella_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_KOOPA= {
    label = {
        left = get_texture_info("koopa_pm1"),
        right = get_texture_info("koopa_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_FLURRIE= {
    label = {
        left = get_texture_info("flurrie_pm1"),
        right = get_texture_info("flurrie_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_BYOSHI= {
    label = {
        left = get_texture_info("byoshi_pm1"),
        right = get_texture_info("byoshi_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_VIVIAN= {
    label = {
        left = get_texture_info("vivian_pm1"),
        right = get_texture_info("vivian_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_BOBBERY= {
    label = {
        left = get_texture_info("bobbery_pm1"),
        right = get_texture_info("bobbery_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local PM_MOWZ= {
    label = {
        left = get_texture_info("mowz_pm1"),
        right = get_texture_info("mowz_pm2"),
    },
    pie = { 
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
        
    }
}

local CUR_SKIN_BY = 1
-- table of skins
local SKINTABLE_BY = {
    { model = E_MODEL_BY_G_1,  name = "Baby Yoshi (Green)",  desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Classic Green flavor!" },    color = { r = 90, g = 255, b = 90 }, icon = TEX_BY_G_1 },
    { model = E_MODEL_BY_R_2,  name = "Baby Yoshi (Red)",    desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Strawberry style!" },        color = { r = 255, g = 110, b = 110 }, icon = TEX_BY_R_2 },
    { model = E_MODEL_BY_B_3,  name = "Baby Yoshi (Blue)",   desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "BlueBerry Blast!" },         color = { r = 100, g = 150, b = 250 }, icon = TEX_BY_B_3 },
    { model = E_MODEL_BY_O_4,  name = "Baby Yoshi (Orange)", desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Orange Juice all the way!" }, color = { r = 255, g = 150, b = 80 }, icon = TEX_BY_O_4 },
    { model = E_MODEL_BY_WM_5, name = "Baby Yoshi (Pink)",   desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Fresh Watermelon Pink!" },   color = { r = 255, g = 160, b = 180 }, icon = TEX_BY_WM_5 },
    { model = E_MODEL_BY_BK_6, name = "Baby Yoshi (Black)",  desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Rebellious Licorice Taste!" }, color = { r = 150, g = 150, b = 150 }, icon = TEX_BY_BK_6 },
    { model = E_MODEL_BY_W_7,  name = "Baby Yoshi (White)",  desc = { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Vanilla Ice Cream!" },       color = { r = 225, g = 225, b = 255 }, icon = TEX_BY_W_7 }
}


if not _G.charSelectExists then
    djui_popup_create(
    "\\#ffffdc\\\n" ..
    TEXT_MOD_NAME ..
    "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end

CT_GOOMBARIO = _G.charSelect.character_add("Goombario",
    "A young member of the Goomba family in Goomba Village, Goombario has always been a big fan of Mario. Like most Goombas, he has a hard head and a fighting spirit. He knows a great deal about the Mushroom Kingdom and will clue you in on most anything you'd like to know.",
    "Melzinoff", { r = 180, g = 116, b = 63 }, E_MODEL_GOOMBARIO, CT_TOAD, TEX_GOOMBARIO)
CT_KOOPER = _G.charSelect.character_add("Kooper",
    "Kooper is Mario's second party member in Paper Mario. He is a blue, bold, adventure-loving (and seemingly young) Koopa who dreams of becoming an archaeologist like his childhood hero Kolorado.",
    "Melzinoff", { r = 55, g = 122, b = 255 }, E_MODEL_KOOPER, CT_LUIGI, TEX_KOOPER)
CT_BOMBETTE = _G.charSelect.character_add("Bombette",
    "Hot-headed Bombette was once jailed in Koopa Bros. Fortress. That pink is adorable!", "Melzinoff",
    { r = 234, g = 0, b = 124 }, E_MODEL_BOMBETTE, CT_MARIO, TEX_BOMBETTE)
CT_PARAKARRY = _G.charSelect.character_add("Parakarry",
    "His name is Parakarry. He's a Paratroopa who works for the post office. He's well known for being the slowest mailman around. A slow mailman? That can't be good.",
    "Melzinoff", { r = 214, g = 131, b = 22 }, E_MODEL_PARAKARRY, CT_LUIGI, TEX_PARAKARRY)
CT_BOW = _G.charSelect.character_add("Lady Bow",
    "Bow is a princess of a Boo, who has a castle in Forever Forest. As the head Boo of Boo's Mansion, she always knows how to get her way.",
    "Melzinoff", { r = 201, g = 217, b = 208 }, E_MODEL_BOW, CT_MARIO, TEX_BOW)
CT_WATT = _G.charSelect.character_add("Watt",
    "The captive of Big Lantern Ghost in Shy Guy's Toy Box, she can shed light on your adventure.",
    "Melzinoff & Gauntlet Queen", { r = 214, g = 208, b = 104 }, E_MODEL_WATT, CT_MARIO, TEX_WATT)
CT_SUSHIE = _G.charSelect.character_add("Sushie",
    "Sushie's a kindly Cheep Cheep who worries about everyone. She loves romantic stories and cries at the drop of a fin.",
    "Melzinoff", { r = 137, g = 103, b = 198 }, E_MODEL_SUSHIE, CT_MARIO, TEX_SUSHIE)
CT_LAKILESTER = _G.charSelect.character_add("Lakilester",
    "Even though it says Lakilester on his cloud riding license, the green-haired Spiny-tosser calls himself Spike.",
    "Melzinoff", { r = 50, g = 164, b = 2 }, E_MODEL_LAKILESTER, CT_MARIO, TEX_LAKILESTER)
CT_GOOMBELLA = _G.charSelect.character_add("Goombella",
    "A female archaeology student at the University of Goom. She can be recognized by her ponytail and pith helmet that features a light that aids her archeological aspirations. With her wealth of knowledge, Goombella serves as Mario's tour guide and assists throughout his adventures. Goooo GOOMBAS!",
    "Melzinoff", { r = 175, g = 179, b = 150 }, E_MODEL_GOOMBELLA, CT_TOAD, TEX_GOOMBELLA)
CT_KOOPS = _G.charSelect.character_add("Koops",
    "Koops is a timid Koopa who wants to be tougher. Kicking some shell never felt so good.", "Melzinoff",
    { r = 166, g = 177, b = 190 }, E_MODEL_KOOPS, CT_LUIGI, TEX_KOOPS)
CT_FLURRIE = _G.charSelect.character_add("Flurrie",
    "Madame Flurrie was a retired actress, just dreaming of coming out of retirement when Mario and friends asked for her help with a small task. She found their stories of adventure alluring, and decided that she would come with them to help as much as she could. Voiced by Lucina Of Stardust",
    "Melzinoff & Lucina Of Stardust", { r = 183, g = 171, b = 206 }, E_MODEL_FLURRIE, CT_WARIO, TEX_FLURRIE)
CT_BY = _G.charSelect.character_add("Baby Yoshi (Green)",
    { "A newborn Yoshi with an attitude!", "Small but packs a punch!", "Classic Green flavor!" },
    "Melzinoff, Sounds by ordatz", { r = 80, g = 250, b = 80 }, E_MODEL_BY_G_1, CT_MARIO, TEX_BY_G_1)
CT_VIVIAN = _G.charSelect.character_add("Vivian",
    "The youngest of the Shadow Sirens, she joins Mario when he shows her an act of kindness. She's the cutest and Transest character in this pack <3, Voiced by wibblus",
    "Melzinoff, wibblus", { r = 163, g = 17, b = 168 }, E_MODEL_VIVIAN, CT_MARIO, TEX_VIVIAN)
CT_BOBBERY = _G.charSelect.character_add("Admiral Bobbery",
    "Admiral Bobbery is a salty old Bob-omb sailor. who was once married to the lovely Scarlette. The workers at the docks say he is some kind of legend.",
    "Melzinoff", { r = 115, g = 78, b = 29 }, E_MODEL_BOBBERY, CT_WARIO, TEX_BOBBERY)
CT_MOWZ = _G.charSelect.character_add("Ms Mowz",
    "That's Ms. Mowz, the thief. She jets off to exotic locales to hunt for rare badges.", "Melzinoff",
    { r = 206, g = 65, b = 0 }, E_MODEL_MOWZ, CT_MARIO, TEX_MOWZ)
CT_BLOOEY = _G.charSelect.character_add("Blooey",
    "Known to his friends as the White Torpedo, is a feisty Blooper who joins Luigi on his quest to rescue Princess Eclair. Although Luigi claims to have successfully thrown Blooey at a monster, killing the golem, he actually tripped and sent Blooey crashing into lava, turning Blooey golden tan.",
    "Melzinoff", { r = 200, g = 164, b = 61 }, E_MODEL_BLOOEY, CT_TOAD, TEX_BLOOEY)
CT_JERRY = _G.charSelect.character_add("Jerry",
    "He's really burning with a righteous fire, and I think he's seen some...horrible...things.", "Melzinoff",
    { r = 206, g = 65, b = 0 }, E_MODEL_JERRY, CT_MARIO, TEX_JERRY)
CT_TORQUE = _G.charSelect.character_add("Torque",
    "I hear he's like, a totally excellent mechanic. According to Mechanics Weekly... that tool on his back can basically do anything. He seems ticked off, though.",
    "Melzinoff", { r = 103, g = 146, b = 46 }, E_MODEL_TORQUE, CT_MARIO, TEX_TORQUE)
CT_HAYZEE = _G.charSelect.character_add("Hayzee",
    "Hayzee is a Crazee Dayzee with green petals, whom Luigi meets during his quest to assemble the Marvelous Compass. Hayzee lived in Jazzafrazz Town, where he wrote a musical entitled The Mystery of The Fiery Hat of Social Awareness for the annual Jazzafrazz Town Drama Slam.",
    "Melzinoff", { r = 161, g = 194, b = 174 }, E_MODEL_HAYZEE, CT_TOAD, TEX_HAYZEE)
CT_SCREAMY = _G.charSelect.character_add("Screamy", "He must deliver something...", "Melzinoff",
    { r = 204, g = 204, b = 204 }, E_MODEL_SCREAMY, CT_MARIO, TEX_SCREAMY)
CT_PRINCESSCC = _G.charSelect.character_add("Princess",
    "Professor Kinopio's Chain Chomp, Princess really lives up to her name, doesn't she? Of course, she could also live up to the name Bruiser or Crusher or Goliath...",
    "Melzinoff", { r = 227, g = 199, b = 200 }, E_MODEL_PRINCESSCC, CT_MARIO, TEX_PRINCESSCC)
CT_SHYBANDIT = _G.charSelect.character_add("The Shy Bandit",
    "A Black Shy Guy who was banished from his homeland, according to a rumor. He is quite the slurper, beware of his fast straw!",
    "Melzinoff", { r = 113, g = 113, b = 113 }, E_MODEL_SHYBANDIT, CT_MARIO, TEX_SHYBANDIT)
CT_PIPER = _G.charSelect.character_add("Piper",
        "A friendly Ptooie friends with five colorful toads, each having received help from him, due to his friendly help, the toads united to revive him using the rainbow carnation he now wears as a brooch.",
        "Melzinoff", { r = 255, g = 0, b = 0 }, E_MODEL_PIPER, CT_MARIO, TEX_PIPER)

    char_add_palette(E_MODEL_GOOMBELLA, PALETTE_GOOMBELLA)
    char_add_palette(E_MODEL_GOOMBARIO, PALETTE_GOOMBARIO)
    char_add_palette(E_MODEL_KOOPER, PALETTE_KOOPER)
    char_add_palette(E_MODEL_KOOPS, PALETTE_KOOPS)
    char_add_palette(E_MODEL_PARAKARRY, PALETTE_PARAKARRY)
    char_add_palette(E_MODEL_BOMBETTE, PALETTE_BOMBETTE)
    char_add_palette(E_MODEL_BOBBERY, PALETTE_BOBBERY)
    char_add_palette(E_MODEL_WATT, PALETTE_WATT)
    char_add_palette(E_MODEL_SUSHIE, PALETTE_SUSHIE)
    char_add_palette(E_MODEL_LAKILESTER, PALETTE_LAKILESTER)
    char_add_palette(E_MODEL_BOW, PALETTE_LADY_BOW)
    char_add_palette(E_MODEL_JERRY, PALETTE_JERRY)
    char_add_palette(E_MODEL_MOWZ, PALETTE_MS_MOWZ)
    char_add_palette(E_MODEL_FLURRIE, PALETTE_MADAME_FLURRIE)
    char_add_palette(E_MODEL_BY_G_1, PALETTE_YOSHI_GREEN)
    char_add_palette(E_MODEL_BY_R_2, PALETTE_YOSHI_RED)
    char_add_palette(E_MODEL_BY_B_3, PALETTE_YOSHI_BLUE)
    char_add_palette(E_MODEL_BY_O_4, PALETTE_YOSHI_ORANGE)
    char_add_palette(E_MODEL_BY_WM_5, PALETTE_YOSHI_WATERMELON)
    char_add_palette(E_MODEL_BY_BK_6, PALETTE_YOSHI_BLACK)
    char_add_palette(E_MODEL_BY_W_7, PALETTE_YOSHI_WHITE)
    char_add_palette(E_MODEL_SCREAMY, PALETTE_SCREAMY)
    char_add_palette(E_MODEL_VIVIAN, PALETTE_VIVIAN)
    char_add_palette(E_MODEL_HAYZEE, PALETTE_HAYZEE)
    char_add_palette(E_MODEL_BLOOEY, PALETTE_BLOOEY)
    char_add_palette(E_MODEL_TORQUE, PALETTE_TORQUE)
    char_add_palette(E_MODEL_PRINCESSCC, PALETTE_PRINCESSCC)
    char_add_palette(E_MODEL_SHYBANDIT, PALETTE_SHYBANDIT)
    char_add_palette(E_MODEL_PIPER, PALETTE_PIPER)

---- BOWSER Compatibility:
if _G.bowsMoveset then
    -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.
    local E_MODEL_SHELL = smlua_model_util_get_id("koopa_shell_geo")
    local E_MODEL_TOR_SHELL = smlua_model_util_get_id("torque_shell_geo")

    -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
    -- Insert each flag you want to be set, separated by '|' symbols.
    local BOWS_FLAGS_KOOPAS = _G.bowsMoveset.FLAG_CAN_USE_SHELL

    -- Flag Options: (sorry the ids are so long pshgkjdf)

    -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
    --- Allows the character to use the shell slide ability.

    -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
    --- Allows the character to use the fire breath ability.

    -- _G.bowsMoveset.FLAG_STYLE_ANIMS
    --- Enables Bowser-unique animations for the character.

    -- _G.bowsMoveset.FLAG_SIZE_ANIMS
    --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)

    -- _G.bowsMoveset.FLAG_LARGE_HITBOX
    --- Gives the character a larger hitbox size. (37 -> 85 units radius)
    --- This does not affect the hitbox size for level collision, only collisions with objects.

    -- _G.bowsMoveset.FLAG_NO_CAPLESS
    --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
    --- Used by Bowser to allow his jaw to open when breathing fire, etc.

    -- _G.bowsMoveset.FLAG_HEAVY_STEPS
    --- Enables heavier landing sound effects for the character.

    -- _G.bowsMoveset.FLAG_ATTACKS
    --- Enables the alternate sliding punch.

    -- _G.bowsMoveset.FLAG_ALL
    --- Shorthand to set all flags.


    -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
    -- parameters: [your character model], [your shell model]
    _G.bowsMoveset.character_add_shell_model(E_MODEL_KOOPER, E_MODEL_SHELL)
    _G.bowsMoveset.character_add_shell_model(E_MODEL_KOOPS, E_MODEL_SHELL)
    _G.bowsMoveset.character_add_shell_model(E_MODEL_PARAKARRY, E_MODEL_SHELL)
    _G.bowsMoveset.character_add_shell_model(E_MODEL_TORQUE, E_MODEL_TOR_SHELL)
    -- This function sets up the flags for your character.
    -- parameters: [your character model], [your flag bitfield]
    _G.bowsMoveset.character_set_bows_flags(E_MODEL_KOOPER, BOWS_FLAGS_KOOPAS)
    _G.bowsMoveset.character_set_bows_flags(E_MODEL_KOOPS, BOWS_FLAGS_KOOPAS)
    _G.bowsMoveset.character_set_bows_flags(E_MODEL_PARAKARRY, BOWS_FLAGS_KOOPAS)
    _G.bowsMoveset.character_set_bows_flags(E_MODEL_TORQUE, BOWS_FLAGS_KOOPAS)
end
----

_G.charSelect.character_add_celebration_star(E_MODEL_GOOMBELLA, E_MODEL_STAR_CRYSTAL, TEX_STAR_CRYSTAL)
_G.charSelect.character_add_celebration_star(E_MODEL_KOOPS, E_MODEL_STAR_DIAMOND, TEX_STAR_DIAMOND)
_G.charSelect.character_add_celebration_star(E_MODEL_FLURRIE, E_MODEL_STAR_EMERALD, TEX_STAR_EMERALD)

_G.charSelect.character_add_celebration_star(E_MODEL_BY_G_1, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_R_2, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_B_3, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_O_4, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_WM_5, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_BK_6, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)
_G.charSelect.character_add_celebration_star(E_MODEL_BY_W_7, E_MODEL_STAR_GOLD, TEX_STAR_GOLD)

_G.charSelect.character_add_celebration_star(E_MODEL_VIVIAN, E_MODEL_STAR_RUBY, TEX_STAR_RUBY)

_G.charSelect.character_add_celebration_star(E_MODEL_BOBBERY, E_MODEL_STAR_SAPPHIRE, TEX_STAR_SAPPHIRE)
_G.charSelect.character_add_celebration_star(E_MODEL_MOWZ, E_MODEL_STAR_GARNET, TEX_STAR_GARNET)

_G.charSelect.character_add_celebration_star(E_MODEL_GOOMBARIO, E_MODEL_STAR_KALMAR, TEX_STAR_KALMAR)

_G.charSelect.character_add_celebration_star(E_MODEL_KOOPER, E_MODEL_STAR_ELDSTAR, TEX_STAR_ELDSTAR)

_G.charSelect.character_add_celebration_star(E_MODEL_BOMBETTE, E_MODEL_STAR_ELDSTAR, TEX_STAR_ELDSTAR)

_G.charSelect.character_add_celebration_star(E_MODEL_PARAKARRY, E_MODEL_STAR_MAMAR, TEX_STAR_MAMAR)

_G.charSelect.character_add_celebration_star(E_MODEL_BOW, E_MODEL_STAR_SKOLAR, TEX_STAR_SKOLAR)

_G.charSelect.character_add_celebration_star(E_MODEL_WATT, E_MODEL_STAR_MUSKULAR, TEX_STAR_MUSKULAR)

_G.charSelect.character_add_celebration_star(E_MODEL_SUSHIE, E_MODEL_STAR_MISSTAR, TEX_STAR_MISSTAR)

_G.charSelect.character_add_celebration_star(E_MODEL_LAKILESTER, E_MODEL_STAR_KLEVAR, TEX_STAR_KLEVAR)


_G.charSelect.character_add_health_meter(CT_KOOPER, PM_KOOPA)
_G.charSelect.character_add_health_meter(CT_PARAKARRY, PM_KOOPA)

_G.charSelect.character_add_health_meter(CT_GOOMBELLA, PM_GOOMBELLA)
_G.charSelect.character_add_health_meter(CT_KOOPS, PM_KOOPA)
_G.charSelect.character_add_health_meter(CT_FLURRIE, PM_FLURRIE)
_G.charSelect.character_add_health_meter(CT_BY, PM_BYOSHI)
_G.charSelect.character_add_health_meter(CT_VIVIAN, PM_VIVIAN)
_G.charSelect.character_add_health_meter(CT_BOBBERY, PM_BOBBERY)
_G.charSelect.character_add_health_meter(CT_MOWZ, PM_MOWZ)


_G.charSelect.character_add_voice(E_MODEL_GOOMBELLA, VOICETABLE_GOOMBA)
_G.charSelect.character_add_voice(E_MODEL_GOOMBARIO, VOICETABLE_GOOMBA)
_G.charSelect.character_add_voice(E_MODEL_KOOPER, VOICETABLE_KOOPA)
_G.charSelect.character_add_voice(E_MODEL_KOOPS, VOICETABLE_KOOPA)
_G.charSelect.character_add_voice(E_MODEL_PARAKARRY, VOICETABLE_KOOPA)
_G.charSelect.character_add_voice(E_MODEL_BOMBETTE, VOICETABLE_BOBOMB)
_G.charSelect.character_add_voice(E_MODEL_BOBBERY, VOICETABLE_BOBOMB)
_G.charSelect.character_add_voice(E_MODEL_WATT, VOICETABLE_WATT)
_G.charSelect.character_add_voice(E_MODEL_SUSHIE, VOICETABLE_SUSHIE)
_G.charSelect.character_add_voice(E_MODEL_LAKILESTER, VOICETABLE_LAKILESTER)
_G.charSelect.character_add_voice(E_MODEL_BOW, VOICETABLE_BOW)
_G.charSelect.character_add_voice(E_MODEL_JERRY, VOICETABLE_BOBOMB)
_G.charSelect.character_add_voice(E_MODEL_MOWZ, VOICETABLE_MOWZ)
_G.charSelect.character_add_voice(E_MODEL_FLURRIE, VOICETABLE_FLURRIE)
_G.charSelect.character_add_voice(E_MODEL_BY_G_1, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_R_2, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_B_3, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_O_4, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_WM_5, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_BK_6, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_BY_W_7, VOICETABLE_BY)
_G.charSelect.character_add_voice(E_MODEL_SCREAMY, VOICETABLE_SILENT)
_G.charSelect.character_add_voice(E_MODEL_VIVIAN, VOICETABLE_VIVIAN)
_G.charSelect.character_add_voice(E_MODEL_HAYZEE, VOICETABLE_HAYZEE)
_G.charSelect.character_add_voice(E_MODEL_BLOOEY, VOICETABLE_BLOOEY)
_G.charSelect.character_add_voice(E_MODEL_TORQUE, VOICETABLE_SILENT)
_G.charSelect.character_add_voice(E_MODEL_PRINCESSCC, VOICETABLE_CHOMP)
_G.charSelect.character_add_voice(E_MODEL_SHYBANDIT, VOICETABLE_SHY)
_G.charSelect.character_add_voice(E_MODEL_PIPER, VOICETABLE_PLANT)


hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_WATT
        or v == VOICETABLE_SUSHIE
        or v == VOICETABLE_LAKILESTER
        or v == VOICETABLE_BOW
        or v == VOICETABLE_MOWZ
        or v == VOICETABLE_FLURRIE
        or v == VOICETABLE_BY
        or v == VOICETABLE_VIVIAN
        or v == VOICETABLE_HAYZEE
        or v == VOICETABLE_BLOOEY
        or v == VOICETABLE_CHOMP
        or v == VOICETABLE_SHY
        or v == VOICETABLE_PLANT
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.sound(m, sound)
    end
end)
hook_event(HOOK_MARIO_UPDATE, function(m)
    local v = _G.charSelect.character_get_voice(m)
    if not v then return end
    if v == VOICETABLE_GOOMBA
        or v == VOICETABLE_KOOPA
        or v == VOICETABLE_BOBOMB
        or v == VOICETABLE_WATT
        or v == VOICETABLE_SUSHIE
        or v == VOICETABLE_LAKILESTER
        or v == VOICETABLE_BOW
        or v == VOICETABLE_MOWZ
        or v == VOICETABLE_FLURRIE
        or v == VOICETABLE_BY
        or v == VOICETABLE_VIVIAN
        or v == VOICETABLE_HAYZEE
        or v == VOICETABLE_BLOOEY
        or v == VOICETABLE_CHOMP
        or v == VOICETABLE_SHY
        or v == VOICETABLE_PLANT
        or v == VOICETABLE_SILENT
    then
        return _G.charSelect.voice.snore(m)
    end
end)

---- alt skin select code for baby josh ----
local function update_character_skin()
    local curSkin = SKINTABLE_BY[CUR_SKIN_BY]
    _G.charSelect.character_edit(CT_BY, curSkin.name, curSkin.desc, nil, curSkin.color, curSkin.model, nil, curSkin.icon)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_BY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_BY < #SKINTABLE_BY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_BY = CUR_SKIN_BY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_BY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_BY = math.max(CUR_SKIN_BY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

-- table to associate animation IDs with our registered lua animation names
local torqueAnims = {
    [CHAR_ANIM_SLOW_LEDGE_GRAB] = 'torque_ledgeup',
    [CHAR_ANIM_BACKWARD_AIR_KB] = 'torque_backward_air_kb',
    [CHAR_ANIM_CLIMB_DOWN_LEDGE] = 'torque_climb_down_ledge',
    [CHAR_ANIM_DIVE] = 'torque_dive',
    [CHAR_ANIM_FALL_FROM_SLIDE] = 'torque_fall_from_slide',
    [CHAR_ANIM_FALL_OVER_BACKWARDS] = 'torque_fall_over_back',
    [CHAR_ANIM_FAST_LEDGE_GRAB] = 'torque_fast_ledge',
    [CHAR_ANIM_FIRST_PERSON] = 'torque_firstperson',
    [CHAR_ANIM_FORWARD_KB] = 'torque_forward_kb',
    [CHAR_ANIM_FORWARD_SPINNING_FLIP] = 'torque_forward_spinning',
    [CHAR_ANIM_HANDSTAND_JUMP] = 'torque_handstand_jump',
    [CHAR_ANIM_HEAD_STUCK_IN_GROUND] = 'torque_head_stuck',
    [CHAR_ANIM_IDLE_HEAD_CENTER] = 'torque_idle_c',
    [CHAR_ANIM_IDLE_HEAD_LEFT] = 'torque_idle_l',
    [CHAR_ANIM_IDLE_HEAD_RIGHT] = 'torque_idle_r',

    [CHAR_ANIM_SLIDE_DIVE] = 'torque_slide_dive',
    [CHAR_ANIM_SLOW_LAND_FROM_DIVE] = 'torque_slow_land_dive',
    [CHAR_ANIM_START_CRAWLING] = 'torque_start_crawling',
    [CHAR_ANIM_STOP_CRAWLING] = 'torque_stop_crawling',
    [CHAR_ANIM_CRAWLING] = 'torque_crawling',
    [CHAR_ANIM_STOP_SLIDE] = 'torque_stop_slide',
    [CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ] = 'torque_stop_slide_light_obj',
    [CHAR_ANIM_SLIDE] = 'torque_slide',
    [CHAR_ANIM_IDLE_ON_LEDGE] = 'torque_idle_on_edge',
    [CHAR_ANIM_START_SLEEP_SITTING] = 'torque_start_sleep_sitting',
    [CHAR_ANIM_SLEEP_IDLE] = 'torque_sleep',


}

-- table associating animation IDs with rotation offsets
local torqueRotOffsets = {
    [CHAR_ANIM_DYING_ON_BACK] = 90,
    [CHAR_ANIM_DYING_ON_STOMACH] = -90,
    [CHAR_ANIM_GRAB_POLE_SHORT] = -80,
    [CHAR_ANIM_GRAB_POLE_SWING_PART1] = -80,
    [CHAR_ANIM_GRAB_POLE_SWING_PART2] = -80,
    [CHAR_ANIM_IDLE_ON_POLE] = -80,
    [CHAR_ANIM_CLIMB_UP_POLE] = -80,
    [CHAR_ANIM_START_HANDSTAND] = -80,
    [CHAR_ANIM_RETURN_FROM_HANDSTAND] = -80,
    [CHAR_ANIM_HANDSTAND_IDLE] = -80,
    [CHAR_ANIM_WATER_IDLE] = -45,
    [CHAR_ANIM_WATER_FORWARD_KB] = -45,
    [CHAR_ANIM_BACKWARDS_WATER_KB] = -45,
    [CHAR_ANIM_SWIM_PART1] = -45,
    [CHAR_ANIM_SWIM_PART2] = -45,
    [CHAR_ANIM_FLUTTERKICK] = -45,
    [CHAR_ANIM_WATER_THROW_OBJ] = -45,
    [CHAR_ANIM_WATER_GRAB_OBJ_PART1] = -45,
    [CHAR_ANIM_WATER_GRAB_OBJ_PART2] = -45,
    [CHAR_ANIM_WATER_ACTION_END] = -45,
}
-- convert angles from degrees to s16
for key, value in pairs(torqueRotOffsets) do
    torqueRotOffsets[key] = value / 180 * 0x8000
end

---@param m MarioState
local function mario_update(m)
    -- check for torque flag; must update animations on every client's end
    if gPlayerSyncTable[m.playerIndex].torque then
        local animID = m.marioObj.header.gfx.animInfo.animID

        -- replaced animations
        local luaAnimID = torqueAnims[animID]
        if luaAnimID then
            -- if the current anim ID has a valid lua anim ID associated with it, play the custom animation
            smlua_anim_util_set_animation(m.marioObj, luaAnimID)
        end

        -- animation rot offsets through code
        local rotOffset = torqueRotOffsets[animID]
        if rotOffset then
            -- if the current anim ID has an associated rotation offset, apply it
            local gfx = m.marioObj.header.gfx
            gfx.angle.x = gfx.angle.x + rotOffset
            -- adjust vertical model position to account for the rotation
            gfx.pos.y = gfx.pos.y + math.max(0, math.abs(rotOffset) - 0x4000) / 0x0200
        end
    end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

hook_event(HOOK_UPDATE, function()
    -- flag to determine if a player is torque (boolean)
    -- this is done in the local update hook because character select can only check for the local player's numbers
    -- gPlayerSyncTable auto syncs the result to all clients
    gPlayerSyncTable[0].torque = (_G.charSelect.character_get_current_number() == CT_TORQUE)
end)
